"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ephemeralRef = void 0;
const runtime_dom_1 = require("@vue/runtime-dom");
function ephemeralRef(delay, fallback) {
    const container = (0, runtime_dom_1.ref)(fallback);
    let timer = null;
    (0, runtime_dom_1.watch)(container, function onNext() {
        if (timer) {
            clearTimeout(timer);
        }
        timer = setTimeout(function onTimeout() {
            timer = null;
            container.value = fallback;
        }, delay);
    });
    return container;
}
exports.ephemeralRef = ephemeralRef;
