"use strict";
/* eslint-disable @typescript-eslint/no-shadow */
Object.defineProperty(exports, "__esModule", { value: true });
exports.eagerComputed = void 0;
const runtime_dom_1 = require("@vue/runtime-dom");
/*
https://dev.to/linusborg/vue-when-a-computed-property-can-be-the-wrong-tool-195j

Use computed() when you have a complex
calculation going on, which can actually profit
from caching and lazy evaluation and should only
be (re-)calculated if really necessary.

Use eagerComputed() when you have a simple
operation, with a rarely changing return value –
often a boolean.
*/
function eagerComputed(factory) {
    const result = (0, runtime_dom_1.shallowRef)();
    (0, runtime_dom_1.watchEffect)(function onEffect() {
        result.value = factory();
    }, { flush: "sync", });
    return (0, runtime_dom_1.readonly)(result);
}
exports.eagerComputed = eagerComputed;
