import { watch } from "@vue/runtime-dom";
export async function until(source, options = {}) {
    let stop = null;
    const { timeout, ...watchOptions } = options;
    const match = options.match === undefined
        ? matchTruthy : options.match instanceof Function
        ? options.match : matcher(options.match);
    const promises = [new Promise(function setup(resolve) {
            stop = watch(source, function onChange(next) {
                if (match(next)) {
                    stop?.();
                    resolve();
                }
            }, watchOptions);
        }),];
    if (timeout) {
        promises.push(new Promise(function setup(_, reject) {
            setTimeout(reject, timeout);
        }).finally(function onFinally() {
            stop?.();
        }));
    }
    return 1 < promises.length ? Promise.race(promises) : promises[0];
}
function matcher(value) {
    return function matches(next) {
        return value === next;
    };
}
function matchTruthy(value) {
    return !!value;
}
