import { ref, watch } from "@vue/runtime-dom";
export function ephemeralRef(delay, fallback) {
    const container = ref(fallback);
    let timer = null;
    watch(container, function onNext() {
        if (timer) {
            clearTimeout(timer);
        }
        timer = setTimeout(function onTimeout() {
            timer = null;
            container.value = fallback;
        }, delay);
    });
    return container;
}
