/* eslint-disable @typescript-eslint/no-shadow */
import { isRef } from "@vue/runtime-dom";
export function extendRef(ref, extend, { enumerable = true, unwrap = true, } = {}) {
    function define(key, value) {
        Object.defineProperty(ref, key, {
            get() { return value.value; },
            set(v) { value.value = v; },
            enumerable,
        });
    }
    for (const [key, value,] of Object.entries(extend)) {
        if ("value" === key) {
            continue;
        }
        if (unwrap && isRef(value)) {
            define(key, value);
        }
        else {
            Object.defineProperty(ref, key, { value, enumerable, });
        }
    }
}
